#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

static int wrap_err(int ret)
{
    if (ret < 0) {
        fprintf(stderr, "ERROR: %s\n", strerror(errno));
        exit(-1);
    }
    return ret;
}

int main()
{
	struct iovec iov;
	char string[256];
	struct msghdr msg;
	int bufsize = 4194304;
    struct sockaddr_in local_addr = {
        .sin_family = AF_INET,
        .sin_port = 0, // Pick whatever free local port
        .sin_addr = 0x0100007F, // 127.0.0.1
    };
    socklen_t addr_len = sizeof(local_addr);
    int listener = wrap_err(socket(AF_INET, SOCK_STREAM, 0));
    int conn = wrap_err(socket(AF_INET, SOCK_STREAM, 0));

    wrap_err(bind(listener, (void*)&local_addr, addr_len));
    wrap_err(listen(listener, SOMAXCONN));
    wrap_err(getsockname(listener, (void*)&local_addr, &addr_len));
    wrap_err(connect(conn, (void*)&local_addr, addr_len));

    int client = wrap_err(accept(listener, (void*)&local_addr, &addr_len));

    // At this point we have 2 connected socket and no longer need a listener
    close(listener);

    setsockopt(client, SOL_SOCKET, SO_SNDBUF, &bufsize, sizeof(bufsize));
    setsockopt(client, SOL_SOCKET, SO_RCVBUF, &bufsize, sizeof(bufsize));
    setsockopt(conn, SOL_SOCKET, SO_SNDBUF, &bufsize, sizeof(bufsize));
    setsockopt(conn, SOL_SOCKET, SO_RCVBUF, &bufsize, sizeof(bufsize));

	memset(&msg, 0, sizeof(msg));
	msg.msg_iov = &iov;
	msg.msg_iovlen = 1;
	iov.iov_base = "Aiya!\n";
	iov.iov_len = 6;
	sendmsg(conn, &msg, 0);
	iov.iov_base = "test";
	iov.iov_len = 4;
	sendmsg(conn, &msg, 0);
	iov.iov_base = "1234567890";
	iov.iov_len = 10;
	sendmsg(conn, &msg, 0);
	iov.iov_base = "1";
	iov.iov_len = 1;
	sendmsg(conn, &msg, 0);

	msg.msg_iov = &iov;
	msg.msg_iovlen = 1;
	iov.iov_base = "Aiya!\n";
	iov.iov_len = 6;
	sendmsg(client, &msg, 0);
	iov.iov_base = "test";
	iov.iov_len = 4;
	sendmsg(client, &msg, 0);
	iov.iov_base = "1234567890";
	iov.iov_len = 10;
	sendmsg(client, &msg, 0);
	iov.iov_base = "1";
	iov.iov_len = 1;
	sendmsg(client, &msg, 0);

	iov.iov_base = string;
	iov.iov_len = 6;
	recvmsg(conn, &msg, 0);
	iov.iov_len = 4;
	recvmsg(conn, &msg, 0);
	iov.iov_len = 10;
	recvmsg(conn, &msg, 0);
	iov.iov_len = 1;
	recvmsg(conn, &msg, 0);

	iov.iov_len = 6;
	recvmsg(client, &msg, 0);
	iov.iov_len = 4;
	recvmsg(client, &msg, 0);
	iov.iov_len = 10;
	recvmsg(client, &msg, 0);
	iov.iov_len = 1;
	recvmsg(client, &msg, 0);

	close(conn);
	close(client);

	printf("Test passed!\n");
}
